#include <NetAddress.h>
#include <NetEndpoint.h>
#include <File.h>
#include <stdio.h>
#include <stdlib.h>
#include <socket.h>
#include <OS.h>
#include <string.h>

#define MIN_PORT	(1)
#define MAX_PORT	(1024)

long PortScan(char *dest, int min_port, int max_port);

int main(int argc, char *argv[])
{
	int i;
	
	if(argc < 2)
	{
		printf("Insuffient number of arguments\n");
		printf("usage: $ portscan <hostname or IP> [<hostname or IP> ...]\n");
		exit(1);
	}
	for(i=1;i<10;i++)
	{
    	// don't process a NULL string
		if(argv[i]==NULL)
			break;
		PortScan(argv[i],MIN_PORT,MAX_PORT);
	}
	return 0;
}	


long PortScan(char *dest, int min_port, int max_port)
{
	BNetAddress addr;
	BNetEndpoint bnep;
	int dport;

	if((addr.InitCheck() < B_OK) || (bnep.InitCheck() < B_OK))
	{
		printf("Initialization Error\n");
		return B_ERROR;
	}
		
	printf("(%s): ",dest);	
	fflush(stdout);	
	// get host info
	for(dport=min_port;dport<max_port;dport++)
	{
		addr.SetTo(dest,dport);
		if(bnep.Connect(addr)==B_OK)
		{
			printf("%i ",dport);
			fflush(stdout);
			bnep.Close();
		}
	}
	printf("\nScan of (%s) complete\n",dest);
	return B_OK;
}
